export declare type Callback<T> = (err: any, value?: T) => void;
export declare type AnyFunction = (...args: Array<any>) => any;
export declare type ClientAPI<M> = {
    id: string;
} & {
    [key in keyof M]: M[key] extends string ? AnyFunction : {
        [key2 in keyof M[key]]: AnyFunction;
    };
};
export declare type Plugin<N, I extends (...args: any) => any> = {
    name: N;
    init: I;
};
export interface SSBClient<M> {
    (cb: Callback<ClientAPI<M>>): void;
    use<N extends keyof any, I extends (...args: any) => any>(plugin: Plugin<N, I>): SSBClient<M & {
        [NN in N]: {
            [P in keyof ReturnType<I>]: string;
        };
    }>;
    callPromise(): Promise<ClientAPI<M>>;
}
export default function ssbClient<M>(manifest: M): SSBClient<M>;
